# include "SlipDef.h"

# include <string>

using namespace std;

namespace slip {

   const string sClassType[ClassType::eSENTINEL]
                        { "UNDEFINED"                 //!< undefined object
                        , "bool     "                 //!< bool      object
                        , "char     "                 //!< char      object
                        , "double   "                 //!< double    object
                        , "header   "                 //!< header    object
                        , "long     "                 //!< long      object
                        , "PTR      "                 //!< pointer   object
                        , "reader   "                 //!< reader    object
                        , "string   "                 //!< string    object
                        , "sublist  "                 //!< sublist   object
                        , "uchar    "                 //!< unsigned char object
                        , "unsigned "                 //!< unsigned long object
                        };
}; // namespace slip
