/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison interface for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

#ifndef YY_YY_SLIPPARSER_H_INCLUDED
# define YY_YY_SLIPPARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif
/* "%code requires" blocks.  */

   # include <stdint.h>
   # include <string>
   # include "SlipCell.h"
   # include "SlipDatum.h"
   # include "SlipDescription.h"
   # include "SlipHeader.h"
   # include "SlipInputMethods.h"
   # include "SlipSublist.h"
 
   # undef BOOL
   # undef CHAR
   # undef FLOAT
   # undef STRING
   # undef UCHAR
   # undef UINTEGER
   # undef INTEGER
   # undef SLIPCELL
   # undef SLIPDATUM
   # undef SLIPHEADER
   # undef SLIPSUBLIST
 
   using namespace std;


#ifdef DEBUG_IO
   #undef DEBUG
   #define DEBUG(flag, stmt) if (flag) { stmt }
#else
   #define DEBUG(flag, stmt)
#endif


/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    yyBOOL = 258,                  /* yyBOOL  */
    yyCHAR = 259,                  /* yyCHAR  */
    yyFLOAT = 260,                 /* yyFLOAT  */
    yyINTEGER = 261,               /* yyINTEGER  */
    yySTRING = 262,                /* yySTRING  */
    yyUCHAR = 263,                 /* yyUCHAR  */
    yyUINTEGER = 264,              /* yyUINTEGER  */
    yyCHARS = 265,                 /* yyCHARS  */
    yyCHARU = 266,                 /* yyCHARU  */
    yyEND = 267,                   /* yyEND  */
    yyNAME = 268,                  /* yyNAME  */
    yyCOLON = 269,                 /* yyCOLON  */
    yyCOMMA = 270,                 /* yyCOMMA  */
    yyHASH = 271,                  /* yyHASH  */
    yyPERIOD = 272,                /* yyPERIOD  */
    yySEMI = 273,                  /* yySEMI  */
    yyINCLUDE = 274,               /* yyINCLUDE  */
    yyLIST = 275,                  /* yyLIST  */
    yyUSER = 276,                  /* yyUSER  */
    yyLPARN = 277,                 /* yyLPARN  */
    yyRPARN = 278,                 /* yyRPARN  */
    yyLBRACE = 279,                /* yyLBRACE  */
    yyRBRACE = 280,                /* yyRBRACE  */
    yyLANGLE = 281,                /* yyLANGLE  */
    yyRANGLE = 282,                /* yyRANGLE  */
    yyBELL = 283,                  /* yyBELL  */
    yyBACK = 284,                  /* yyBACK  */
    yyFF = 285,                    /* yyFF  */
    yyLF = 286,                    /* yyLF  */
    yyCR = 287,                    /* yyCR  */
    yyHT = 288                     /* yyHT  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
                               //!< Token values
   bool              BOOL;                     //!< token boolean true / false
   int8_t            CHAR;                     //!< 8-bit  token value
   double            FLOAT;                    //!< 64-bit token value
   int32_t           INTEGER;                  //!< 32-bit token value
   string*           STRING;                   //!< pointer to new string()
   uint8_t           UCHAR;                    //!< 8-bit unsigned value
   uint32_t          UINTEGER;                 //!< 32-bit unsigned value
   SlipCell*         SLIPCELL;                 //!< general slip cell
   SlipDatum*        SLIPDATUM;                //!< data carrying SLIP cell
   SlipHeader*       SLIPHEADER;               //!< list header
   SlipSublist*      SLIPSUBLIST;              //!< list sublist
   SlipDescription*  DESCRIPTION;              //!< descriptionList data passage


};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE yylval;
extern YYLTYPE yylloc;

int yyparse (SlipHeader** head, SlipInputMethods* methods);


#endif /* !YY_YY_SLIPPARSER_H_INCLUDED  */
